VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.MDIForm frmMain 
   Appearance      =   0  'Flat
   BackColor       =   &H8000000C&
   Caption         =   "Viking Compiler"
   ClientHeight    =   6675
   ClientLeft      =   60
   ClientTop       =   630
   ClientWidth     =   10110
   Icon            =   "frmMain.frx":0000
   StartUpPosition =   2  'CenterScreen
   Begin VB.PictureBox pFiles 
      Align           =   2  'Align Bottom
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      Height          =   675
      Left            =   0
      ScaleHeight     =   675
      ScaleWidth      =   10110
      TabIndex        =   1
      Top             =   5685
      Visible         =   0   'False
      Width           =   10110
      Begin VB.FileListBox files 
         Height          =   480
         Left            =   2280
         TabIndex        =   3
         Top             =   60
         Width           =   1515
      End
      Begin VB.DirListBox dirs 
         Height          =   540
         Left            =   60
         TabIndex        =   2
         Top             =   60
         Width           =   2175
      End
   End
   Begin VB.PictureBox sts 
      Align           =   2  'Align Bottom
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'None
      BeginProperty Font 
         Name            =   "Verdana"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   0
      ScaleHeight     =   315
      ScaleWidth      =   10110
      TabIndex        =   0
      Top             =   6360
      Width           =   10110
   End
   Begin MSComDlg.CommonDialog cdl 
      Left            =   60
      Top             =   5160
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      DefaultExt      =   "vc"
      Filter          =   "Supported files|*.vc;*.lib|Source files|*.vc|Library files|*.lib|All files|*.*"
      FilterIndex     =   1
      Flags           =   4
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileNew 
         Caption         =   "&New"
         Shortcut        =   ^N
      End
      Begin VB.Menu mnuFileOpen 
         Caption         =   "&Open..."
         Shortcut        =   ^O
      End
      Begin VB.Menu mnuFileSep1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "&Exit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpContents 
         Caption         =   "&Help contents"
         Shortcut        =   {F1}
      End
      Begin VB.Menu mnuHelpSep1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About..."
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private WithEvents MDITabs As cMDITabs
Attribute MDITabs.VB_VarHelpID = -1

Private Declare Function OleTranslateColor Lib "OLEPRO32.DLL" (ByVal OLE_COLOR As Long, ByVal HPALETTE As Long, pccolorref As Long) As Long
Private Const CLR_INVALID = -1

Private WinCount As Long, sStatusText As String, bStatusModified As Boolean
Public NeedsCompile As Boolean, sCompileFile As String

Public Function NewEditor() As frmEditor
    Dim NewEd As frmEditor
    Set NewEd = New frmEditor
    NewEd.Show
    WinCount = WinCount + 1
    NewEd.Caption = "Untitled " & WinCount
    NewEd.cs.Text = "application Untitled, 1.0.0.0, GUI;" & vbCrLf & vbCrLf & "begin" & vbCrLf & vbCrLf & vbTab & vbCrLf & vbCrLf & "end."
    NewEd.cs.SetCaretPos 4, 1
    Set NewEditor = NewEd
    MDITabs.ForceRefresh
End Function

Public Sub OpenFile(Optional sFile As String = "")
    Dim frmChild As Form, bExists As Boolean
    If sFile = "" Then
        cdl.ShowOpen
    Else
        cdl.Filename = sFile
    End If
    If cdl.Filename <> "" Then
        bExists = False
        For Each frmChild In Forms
            If TypeName(frmChild) = "frmEditor" Then
                If frmChild.Filename = cdl.Filename Then
                    bExists = True
                    frmChild.SetFocus
                End If
            End If
        Next
        If Not bExists Then NewEditor().OpenFile cdl.Filename
        MDITabs.ForceRefresh
    End If
End Sub

Public Sub SaveAll()
    Dim frmChild As Form
    For Each frmChild In Forms
        If TypeName(frmChild) = "frmEditor" Then
            If frmChild.Filename <> "" Then frmChild.SaveFile
        End If
    Next
    MDITabs.ForceRefresh
End Sub

Public Sub CloseAll()
    Dim frmChild As Form
    For Each frmChild In Forms
        If TypeName(frmChild) <> "frmMain" Then
            Unload frmChild
        End If
    Next
    MDITabs.ForceRefresh
End Sub

Public Sub RefreshTabs()
    MDITabs.ForceRefresh
End Sub

Public Sub CompileSource(bRun As Boolean)
    Dim frmChild As Form
    For Each frmChild In Forms
        If TypeName(frmChild) = "frmEditor" Then
            If frmChild.Filename = sCompileFile Then
                frmChild.SetFocus
                Exit For
            End If
        End If
    Next
    Set frmChild = ActiveForm
    frmChild.Enabled = False
    frmChild.mnuMake.Enabled = False
    frmChild.cs.Enabled = False
    If bRun Then
        If NeedsCompile Then Compile
    Else
        Compile
    End If
    NeedsCompile = False
    frmChild.cs.Enabled = True
    frmChild.mnuMake.Enabled = True
    frmChild.Enabled = True
    ActiveForm.cs.SetFocus
    If bRun Then Run
End Sub

Public Sub ShowAbout()
    MsgBox "Viking Compiler Version " & App.Major & "." & App.Minor & "." & App.Revision & vbCrLf & _
        App.LegalCopyright & vbCrLf & "All rights reserved."
End Sub

Public Property Let StatusText(ByVal sNewValue As String)
    sStatusText = sNewValue
    UpdateStatusbar
End Property

Public Property Let StatusModified(ByVal bNewValue As Boolean)
    bStatusModified = bNewValue
    UpdateStatusbar
End Property

Private Function TranslateColor(ByVal oClr As OLE_COLOR, Optional hPal As Long = 0) As Long
    If OleTranslateColor(oClr, hPal, TranslateColor) Then TranslateColor = CLR_INVALID
End Function

Public Function BlendColor(ByVal oColorFrom As OLE_COLOR, ByVal oColorTo As OLE_COLOR, Optional ByVal alpha As Long = 128) As Long
    Dim lCFrom As Long
    Dim lCTo As Long
    lCFrom = TranslateColor(oColorFrom)
    lCTo = TranslateColor(oColorTo)
    Dim lSrcR As Long
    Dim lSrcG As Long
    Dim lSrcB As Long
    Dim lDstR As Long
    Dim lDstG As Long
    Dim lDstB As Long
    lSrcR = lCFrom And &HFF
    lSrcG = (lCFrom And &HFF00&) \ &H100&
    lSrcB = (lCFrom And &HFF0000) \ &H10000
    lDstR = lCTo And &HFF
    lDstG = (lCTo And &HFF00&) \ &H100&
    lDstB = (lCTo And &HFF0000) \ &H10000
    BlendColor = RGB(((lSrcR * alpha) / 255) + ((lDstR * (255 - alpha)) / 255), ((lSrcG * alpha) / 255) + ((lDstG * (255 - alpha)) / 255), ((lSrcB * alpha) / 255) + ((lDstB * (255 - alpha)) / 255))
End Function

Private Sub UpdateStatusbar()
    Dim lSplit As Long
    lSplit = sts.ScaleWidth - 165 - sts.TextWidth("Modified")
    sts.Cls
    sts.Line (15, 30)-(lSplit - 60, sts.ScaleHeight - 30), BlendColor(vbButtonFace, vbWindowBackground), B
    sts.CurrentX = 90
    sts.CurrentY = 60
    sts.Print sStatusText
    sts.Line (lSplit, 30)-(sts.ScaleWidth - 30, sts.ScaleHeight - 30), BlendColor(vbButtonFace, vbWindowBackground), B
    sts.CurrentX = sts.ScaleWidth - 90 - sts.TextWidth("Modified")
    sts.CurrentY = 60
    sts.Print IIf(bStatusModified, "Modified", "")
End Sub

Public Sub Progress(lStep As Long, lMax As Long, sText As String)
    On Error Resume Next
    Dim lRight As Long
    StatusText = ""
    If lStep = lMax Then
        ActiveForm.UpdatePos
        Exit Sub
    End If
    lRight = sts.ScaleWidth - 225 - sts.TextWidth("Modified")
    sts.Line (15, 30)-((lStep / lMax) * lRight, sts.ScaleHeight - 30), BlendColor(vbButtonFace, vbWindowBackground), BF
    sts.CurrentX = 90
    sts.CurrentY = 60
    sts.Print sText
    DoEvents
End Sub

Private Sub MDIForm_Load()
    Dim sFile As String, i As Long, inQuotes As Boolean, lLastPos As Long
    Set MDITabs = New cMDITabs
    MDITabs.Attach Me.hWnd
    sCompileFile = ""
    WinCount = 0
    InitCompiler
    inQuotes = False: lLastPos = 1
    If Command <> "" Then
        For i = 1 To Len(Command)
            If mId(Command, i, 1) = """" Then
                inQuotes = Not inQuotes
            ElseIf mId(Command, i, 1) = " " And Not inQuotes Then
                sFile = GetFullFilename(mId(Command, lLastPos, i - lLastPos))
                If Not FileExists(sFile) Then
                    MsgBox "File '" & sFile & "' does not exist.", , "Open"
                Else
                    NewEditor().OpenFile sFile
                End If
                lLastPos = i + 1
            End If
        Next i
        sFile = GetFullFilename(mId(Command, lLastPos, Len(Command) - lLastPos + 1))
        If Not FileExists(sFile) Then
            MsgBox "File '" & sFile & "' does not exist.", , "Open"
        Else
            NewEditor().OpenFile sFile
        End If
    End If
    sts.Height = sts.TextHeight("A") + 120
    StatusText = ""
    MDITabs.ForceRefresh
End Sub

Private Sub MDIForm_Unload(Cancel As Integer)
    CloseAll
    If Not ActiveForm Is Nothing Then Cancel = True
End Sub

Private Sub MDITabs_CloseWindow(ByVal hWnd As Long)
    Dim frmChild As Form
    For Each frmChild In Forms
        If frmChild.hWnd = hWnd Then
            Unload frmChild
            MDITabs.ForceRefresh
            Exit Sub
        End If
    Next
End Sub

Private Sub mnuFileExit_Click()
    Unload Me
End Sub

Private Sub mnuFileNew_Click()
    NewEditor
End Sub

Private Sub mnuFileOpen_Click()
    OpenFile
End Sub

Private Sub mnuHelpAbout_Click()
    ShowAbout
End Sub

Private Sub mnuHelpContents_Click()
    frmHelp.Show
    frmHelp.ShowHelp ""
    MDITabs.ForceRefresh
End Sub

Private Sub sts_Resize()
    UpdateStatusbar
End Sub
