Attribute VB_Name = "modAssembler"
Option Explicit

Public Enum ImmRelation
    irE = &H400
    irNE = &H500
    irG = &HF00
    irL = &HC00
    irGE = &HD00
    irLE = &HE00
End Enum

Sub Jump(label As String)
    AddCodeByte &HE9
    CodeFixup label, UBound(CodeSection) + 4
End Sub

Sub StdCall(label As String, ParamCount As Integer)
    AddCodeByte &HE8
    CodeFixup label, UBound(CodeSection) + 4, ParamCount
End Sub

Sub Invoke(label As String, ParamCount As Integer)
    Dim a As ALIAS_ITEM, i As Long
    a = GetAlias(label)
    Import a.Name, a.Library
    AddCodeWord &H15FF
    CodeFixup a.Name & "@" & a.Library
    If a.ParamCount > -1 And a.ParamCount <> ParamCount Then errInvalidParamCount
    If Not a.PopParams Then Exit Sub
    AddCodeWord &HC481
    AddCodeDWord ParamCount * 4
End Sub

Function GetAddress(label As String, Optional AllowIndex As Boolean = True, Optional IsAssignment As Boolean = False) As Boolean
    GetAddress = False
    If InStr(label, "@") Then
        AddCodeByte &HB8
        CodeFixup label
        AddCodeWord &H8B
        Exit Function
    ElseIf GetSymbol(label).sType = stLocal Then
        AddCodeWord &H858D
        AddCodeDWord GetSymbol(label).Offset
        If GetSymbol(label).Parameter And (GetSymbol(label).TypeName = "char" Or GetSymbol(label).Pointer) Then
            AddCodeWord &H8B
            If GetSymbol(label).Index <> 0 Then
                AddCodeByte &H5
                AddCodeDWord GetSymbol(label).Index
            End If
        End If
    Else
        AddCodeByte &HB8
        CodeFixup label
    End If
    If IsSymbol("[") And (GetSymbol(label).TypeName = "char" Or GetSymbol(label).TypeName = "dword") Then
        If GetSymbol(label).TypeName = "dword" Then AddCodeWord &H8B
        Expr_Push
        Symbol "["
        Expression
        Symbol "]"
        Expr_Add
        If IsAssignment Then
            sCurrType = "byte"
        Else
            GetAddress = True
        End If
    End If
End Function

Sub Store()
    If sCurrType = "char" Then
        AddCodeByte &H5A
        Expr_Push
        AddCodeByte &H52
        Invoke "Copy", 2
    Else
        AddCodeByte &H5A
        Expr_Push
        AddCodeWord &HD089
        Select Case GetTypeSize(sCurrType)
        Case 1
            AddCodeByte &H59
            AddCodeWord &H888
        Case 2
            AddCodeDWord &H8896659
        Case 4
            AddCodeByte &H59
            AddCodeWord &H889
        End Select
    End If
End Sub

Sub LoadVar(label As String, Optional Pointer As Boolean = False)
    Dim bIsByte As Boolean, a As ALIAS_ITEM
    If AliasExists(label) Then
        a = GetAlias(label)
        Import a.Name, a.Library
        GetAddress a.Name & "@" & a.Library, False
        Exit Sub
    ElseIf GetSymbol(label).sType = stFunction Then
        GetAddress label, False
        Exit Sub
    End If
    bIsByte = GetAddress(label)
    If Pointer And Not bIsByte Then Exit Sub
    Select Case GetTypeSize(GetSymbol(label).TypeName)
    Case 1
        AddCodeByte &HF
        AddCodeWord &HBE
    Case 2
        AddCodeByte &HF
        AddCodeWord &HBF
    Case 4
        AddCodeWord &H8B
    Case Else
        If bIsByte Then
            AddCodeByte &HF
            AddCodeWord &HBE
        End If
    End Select
End Sub

Sub Increase()
    Select Case GetTypeSize(sCurrType)
    Case 1
        AddCodeByte &H58
        AddCodeWord &HFE
    Case 2
        AddCodeDWord &HFF6658
    Case 4
        AddCodeByte &H58
        AddCodeWord &HFF
    Case Else
        errCantAssign sCurrType
    End Select
End Sub

Sub Decrease()
    Select Case GetTypeSize(sCurrType)
    Case 1
        AddCodeByte &H58
        AddCodeWord &H8FE
    Case 2
        AddCodeDWord &H8FF6658
    Case 4
        AddCodeByte &H58
        AddCodeWord &H8FF
    Case Else
        errCantAssign sCurrType
    End Select
End Sub

Sub LoadImm(Value As Long)
    AddCodeByte &HB8
    AddCodeDWord Value
End Sub

Sub Expr_Push()
    AddCodeByte &H50
End Sub

Sub Expr_Add()
    AddCodeWord &H159
    AddCodeByte &HC8
End Sub

Sub Expr_Sub()
    AddCodeWord &H2959
    AddCodeByte &HC8
    Expr_Neg
End Sub

Sub Expr_Mul()
    AddCodeDWord &HF759D231
    AddCodeByte &HE9
End Sub

Sub Expr_Div()
    AddCodeDWord &H9159D231
    AddCodeWord &HF9F7
End Sub

Sub Expr_Mod()
    Expr_Div
    AddCodeWord &HD089
End Sub

Sub Expr_Or()
    AddCodeByte &H59
    AddCodeWord &HC809
End Sub

Sub Expr_Xor()
    AddCodeByte &H59
    AddCodeWord &HC133
End Sub

Sub Expr_And()
    AddCodeByte &H59
    AddCodeWord &HC821
End Sub

Sub Expr_Neg()
    AddCodeWord &HD8F7
End Sub

Sub Expr_Not()
    AddCodeWord &HD0F7
End Sub

Sub Expr_Shl()
    AddCodeDWord &HE0D39159
End Sub

Sub Expr_Shr()
    AddCodeDWord &HE8D39159
End Sub

Sub Expr_Cmp()
    AddCodeWord &H3959
    AddCodeByte &HC1
End Sub

Sub Expr_SetCC(Rel As ImmRelation)
    AddCodeWord &H900F + Rel
    AddCodeByte &HC0
    AddCodeWord &HE083
    AddCodeByte 1
End Sub

Sub Expr_Test(label As String)
    AddCodeDWord &HE0BA0F
    AddCodeWord &H830F
    CodeFixup label, UBound(CodeSection) + 4
End Sub

Sub Expr_MovECXEAX()
    AddCodeWord &HC189
End Sub

Sub Expr_PushECX()
    AddCodeByte &H51
End Sub

Sub Expr_PopECX()
    AddCodeByte &H59
End Sub

Sub Expr_DecECX()
    AddCodeByte &H49
End Sub

Sub Expr_TestECX(label As String)
    AddCodeDWord &H850FC985
    CodeFixup label, UBound(CodeSection) + 4
End Sub

Sub StartFrame()
    AddCodeWord &H8955
    AddCodeByte &HE5
End Sub

Sub LocalDataSize(Value As Long)
    If Value = 0 Then Exit Sub
    AddCodeWord &HEC81
    AddCodeDWord Align4(Value)
End Sub

Sub EndFrame(Value As Integer)
    AddCodeWord &HC2C9
    AddCodeWord Value
End Sub
