Attribute VB_Name = "modErrors"
Option Explicit

Public bError As Boolean

Sub CompileError(sMessage As String)
    On Error Resume Next
    If bError Then Exit Sub
    Message "Can not complete the compilation process." & vbCrLf & _
        "Error[" & IIf(Len(Trim(sCurrentFile)), GetFileTitle(sCurrentFile) & ": ", "") & lCurrentLine & "]: " & sMessage & "."
    If Len(Trim(sCurrentFile)) Then
        frmMain.OpenFile GetRealFilename(sCurrentFile)
        frmMain.ActiveForm.ErrorLine lCurrentLine
    Else
        frmMain.ActiveForm.ErrorLine lCurrentLine
    End If
    bError = True
    sCode = ""
End Sub

Sub errFileNotFound(sName As String)
    CompileError "the file '" & GetFileTitle(sName) & "' does not exist"
End Sub

Sub errIdentNotFound(sName As String)
    CompileError "identifier '" & sName & "' not found"
End Sub

Sub errTypeNotFound(sName As String)
    CompileError "type '" & sName & "' not found"
End Sub

Sub errUnexpected(sExpected As String)
    Dim sFound As String
    If IsBlank Then Blank
    If Len(sCode) = 0 Then
        sFound = "end of file"
    ElseIf IsIdentifier Then
        sFound = "identifier"
    ElseIf IsNumber Then
        sFound = "integer"
    ElseIf IsText Then
        sFound = "string"
    ElseIf IsTerminator Then
        sFound = "terminator"
    ElseIf Locked(2) = vbCrLf Then
        sFound = "new line"
    ElseIf IsBlank Then
        sFound = "blank"
    Else
        sFound = "symbol '" & Locked & "'"
    End If
    CompileError "expected " & sExpected & ", but found " & sFound
End Sub

Sub errUnexpectedEx(sExpected As String, sFound As String)
    CompileError "expected " & sExpected & ", but found " & sFound
End Sub

Sub errUnterminated()
    CompileError "unterminated string"
End Sub

Sub errEmptyType()
    CompileError "types with no members are not allowed"
End Sub

Sub errIdentifierExists(sIdent As String)
    CompileError "identifier '" & sIdent & "' already exists"
End Sub

Sub errTypeExists(sIdent As String)
    CompileError "type '" & sIdent & "' already exists"
End Sub

Sub errValueOutOfRange()
    CompileError "value out of range"
End Sub

Sub errInvalidType(sType As String)
    CompileError "invalid type '" & sType & "'"
End Sub

Sub errCallVariable(sName As String)
    CompileError "can not call the variable '" & sName & "'"
End Sub

Sub errResIdentUsedAsIdent(sIdent As String)
    CompileError "reserved identifier '" & sIdent & "' used as identifier"
End Sub

Sub errCantAssign(sType As String)
    CompileError "can not assign value to type '" & sType & "'"
End Sub

Sub errInvalidParamCount()
    CompileError "invalid count of parameters"
End Sub

Sub errUnknownLibrary(sLib As String)
    CompileError "unknown library '" & sLib & "'"
End Sub

Sub errAliasAsPtrValue()
    CompileError "can not refer to an alias"
End Sub

Sub errInvalidDirective(sIdent As String)
    CompileError "invalid resource directive '" & sIdent & "'"
End Sub

Sub errInvalidFileFormat()
    CompileError "invalid format of file"
End Sub
