Attribute VB_Name = "modExpressions"
Option Explicit

Public sCurrType As String

Function IsAssignment() As Boolean
    IsAssignment = IsSymbol(":=") Or IsSymbol("++") Or IsSymbol("--") Or IsSymbol("(") Or IsSymbol("[")
End Function

Sub Assignment()
    Dim sIdent As String
    sIdent = Identifier
    If Not IsAssignment Then errUnexpected "assignment"
    If SymbolTypeExists(sIdent) Then
        sCurrType = sIdent
        Symbol "["
        Expression
        Symbol "]"
    Else
        If IsSymbol("(") Then
            FunctionCall sIdent
            Terminator
            Exit Sub
        End If
        sCurrType = GetSymbol(sIdent).TypeName
        GetAddress sIdent, True, True
    End If
    Expr_Push
    If IsSymbol(":=") Then
        Symbol ":=": Expression: Store
    ElseIf IsSymbol("++") Then
        Symbol "++": Increase
    ElseIf IsSymbol("--") Then
        Symbol "--": Decrease
    End If
    Terminator
End Sub

Function IsAddOp() As Boolean
    IsAddOp = IsSymbol("+") Or IsSymbol("-") Or IsSymbol("#")
End Function

Function IsMulOp() As Boolean
    IsMulOp = IsSymbol("*") Or IsSymbol("/") Or IsSymbol("%") Or IsSymbol("<<") Or IsSymbol(">>")
End Function

Function IsRelOp() As Boolean
    IsRelOp = IsSymbol("=") Or IsSymbol("!=") Or IsSymbol("<>") Or IsSymbol(">=") Or IsSymbol("<=") Or IsSymbol("=>") Or IsSymbol("=<") Or IsSymbol(">") Or IsSymbol("<") Or IsSymbol("==") Or IsSymbol("~=") Or IsSymbol("!==") Or IsSymbol("!~=") Or IsSymbol("?")
End Function

Function IsBoolOp() As Boolean
    IsBoolOp = IsSymbol("|") Or IsSymbol("~") Or IsSymbol("&")
End Function

Function ConstantExpression() As Long
    Symbol "["
    ConstantExpression = Number
    While IsAddOp Or IsBoolOp
        If IsSymbol("+") Then
            Symbol "+"
            ConstantExpression = ConstantExpression + Number
        ElseIf IsSymbol("-") Then
            Symbol "-"
            ConstantExpression = ConstantExpression - Number
        ElseIf IsSymbol("|") Then
            Symbol "|"
            If IsSymbol("!") Then
                Symbol "!"
                ConstantExpression = ConstantExpression Or Not Number
            Else
                ConstantExpression = ConstantExpression Or Number
            End If
        ElseIf IsSymbol("&") Then
            Symbol "&"
            If IsSymbol("!") Then
                Symbol "!"
                ConstantExpression = ConstantExpression And Not Number
            Else
                ConstantExpression = ConstantExpression And Number
            End If
        ElseIf IsSymbol("~") Then
            Symbol "~"
            ConstantExpression = ConstantExpression Xor Number
        End If
    Wend
    Symbol "]"
End Function

Sub Expression()
    Relation
    While IsBoolOp
        Expr_Push
        If IsSymbol("|") Then
            Symbol "|": Relation: Expr_Or
        ElseIf IsSymbol("~") Then
            Symbol "~": Relation: Expr_Xor
        ElseIf IsSymbol("&") Then
            Symbol "&": Relation: Expr_And
        End If
    Wend
End Sub

Sub Relation()
    Expr
    While IsRelOp
        If Len(sCurrentProc) > 0 Then AddCodeByte &H55
        Expr_Push
        If IsSymbol("!==") Then
            Symbol "!==": Expr: Expr_Push
            Invoke "Compare", 2: Expr_SetCC irNE
        ElseIf IsSymbol("!~=") Then
            Symbol "!~=": Expr: Expr_Push
            Invoke "CompareI", 2: Expr_SetCC irNE
        ElseIf IsSymbol("!=") Then
            Symbol "!=": Expr: Expr_Cmp: Expr_SetCC irNE
        ElseIf IsSymbol("==") Then
            Symbol "==": Expr: Expr_Push
            Invoke "Compare", 2: Expr_SetCC irE
        ElseIf IsSymbol("~=") Then
            Symbol "~=": Expr: Expr_Push
            Invoke "CompareI", 2: Expr_SetCC irE
        ElseIf IsSymbol("<>") Then
            Symbol "<>": Expr: Expr_Cmp: Expr_SetCC irNE
        ElseIf IsSymbol(">=") Then
            Symbol ">=": Expr: Expr_Cmp: Expr_SetCC irGE
        ElseIf IsSymbol("<=") Then
            Symbol "<=": Expr: Expr_Cmp: Expr_SetCC irLE
        ElseIf IsSymbol("=>") Then
            Symbol "=>": Expr: Expr_Cmp: Expr_SetCC irGE
        ElseIf IsSymbol("=<") Then
            Symbol "=<": Expr: Expr_Cmp: Expr_SetCC irLE
        ElseIf IsSymbol(">") Then
            Symbol ">": Expr: Expr_Cmp: Expr_SetCC irG
        ElseIf IsSymbol("<") Then
            Symbol "<": Expr: Expr_Cmp: Expr_SetCC irL
        ElseIf IsSymbol("=") Then
            Symbol "=": Expr: Expr_Cmp: Expr_SetCC irE
        ElseIf IsSymbol("?") Then
            Symbol "?": Symbol "[": Expr: Expr_Cmp: AddCodeByte &H51: Expr_SetCC irGE: AddCodeWord &HC389
            Symbol "..": Expr: Expr_Cmp: Expr_SetCC irLE: AddCodeWord &HD821: Symbol "]"
        End If
        If Len(sCurrentProc) > 0 Then AddCodeByte &H5D
    Wend
End Sub

Sub Expr()
    Term
    While IsAddOp
        Expr_Push
        If IsSymbol("+") Then
            Symbol "+": Term: Expr_Add
        ElseIf IsSymbol("-") Then
            Symbol "-": Term: Expr_Sub
        ElseIf IsSymbol("#") Then
            Symbol "#"
            Factor
            Expr_PopECX
            If Len(sCurrentProc) > 0 Then AddCodeByte &H55
            Expr_Push
            Expr_PushECX
            Invoke "Append", 2
            If Len(sCurrentProc) > 0 Then AddCodeByte &H5D
        End If
    Wend
End Sub

Sub Term()
    Factor
    While IsMulOp
        Expr_Push
        If IsSymbol("*") Then
            Symbol "*": Factor: Expr_Mul
        ElseIf IsSymbol("/") Then
            Symbol "/": Factor: Expr_Div
        ElseIf IsSymbol("%") Then
            Symbol "%": Factor: Expr_Mod
        ElseIf IsSymbol("<<") Then
            Symbol "<<": Factor: Expr_Shl
        ElseIf IsSymbol(">>") Then
            Symbol ">>": Factor: Expr_Shr
        End If
    Wend
End Sub

Sub Factor()
    Dim bNot As Boolean, bNeg As Boolean, bPtr As Boolean, sIdent As String, lTemp As Long
    bNot = IsSymbol("!")
    bNeg = IsSymbol("-")
    bPtr = IsSymbol("^")
    If bNot Then Symbol "!"
    If bNeg Then Symbol "-"
    If bPtr Then Symbol "^"
    If IsNumber Then
        LoadImm Number
    ElseIf IsIdentifier Then
        sIdent = Identifier
        If IsSymbol("(") Then
            If LCase(sIdent) = "sizeof" Then
                Symbol "("
                sIdent = Identifier
                If SymbolExists(sIdent) Then
                    sIdent = GetSymbol(sIdent).UserDefined
                End If
                If SymbolTypeExists(sIdent) Then
                    LoadImm GetSymbolType(sIdent).Size
                Else
                    errInvalidType sIdent
                End If
                Symbol ")"
            Else
                FunctionCall sIdent
            End If
        Else
            LoadVar sIdent, False
        End If
    ElseIf IsSymbol("@") Then
        Symbol "@"
        LoadVar Identifier, True
    ElseIf IsSymbol("(") Then
        Symbol "("
        Expression
        Symbol ")"
    ElseIf IsText Then
        sIdent = Text
        If TextPos(sIdent) = 0 Then
            AddSymbol "$str" & lUniqueID, 0, stIData, stGlobal, "char"
            AddIDataString sIdent
        Else
            AddSymbol "$str" & lUniqueID, 0, stIData, stGlobal, "char", TextPos(sIdent)
        End If
        LoadVar "$str" & lUniqueID, True
        lUniqueID = lUniqueID + 1
    Else
        errUnexpected "factor"
    End If
    While IsBlank
        Skip
    Wend
    If bPtr Then AddCodeWord &H8B
    If bNeg Then Expr_Neg
    If bNot Then Expr_Not
End Sub

Sub FunctionCall(sIdent As String)
    Dim lParamCount As Integer
    Symbol "("
    lParamCount = 0
    ReverseParams
    While IsBlank
        Skip
    Wend
    If Len(sCurrentProc) > 0 Then AddCodeByte &H55
    While Not IsSymbol(")")
        Expression
        Expr_Push
        lParamCount = lParamCount + 1
        If Not IsSymbol(")") Then Symbol (",")
        If Len(sCode) = 0 Then Exit Sub
    Wend
    Symbol ")"
    If SymbolExists(sIdent) Then
        If GetSymbol(sIdent).TypeName = "ptr" Then
            AddCodeWord &H15FF
            CodeFixup sIdent
        ElseIf GetSymbol(sIdent).sType = stFunction Then
            StdCall sIdent, lParamCount
        Else
            errCallVariable sIdent
        End If
    ElseIf AliasExists(sIdent) Then
        Invoke sIdent, lParamCount
    Else
        StdCall sIdent, lParamCount
    End If
    If Len(sCurrentProc) > 0 Then AddCodeByte &H5D
End Sub

Sub ReverseParams()
    Dim i As Long, ii As Long, Params() As String, pLevel As Integer
    ReDim Preserve Params(1) As String: i = 1: pLevel = 0
    While i <= Len(sCode)
        If mId(sCode, i, 1) = "," And pLevel = 0 Then
            Params(UBound(Params)) = Left(sCode, i - 1)
            sCode = mId(sCode, i + 1)
            ReDim Preserve Params(UBound(Params) + 1) As String
            i = 1: pLevel = 0
        ElseIf mId(sCode, i, 1) = """" Then
            For ii = i + 1 To Len(sCode)
                If mId(sCode, ii, 1) = "\" Then
                    ii = ii + 1
                ElseIf mId(sCode, ii, 1) = """" Then
                    i = ii + 1
                    Exit For
                End If
                If ii = Len(sCode) Then errUnterminated
            Next ii
        ElseIf mId(sCode, i, 1) = "(" Then
            pLevel = pLevel + 1
            i = i + 1
        ElseIf mId(sCode, i, 1) = ")" Then
            If pLevel > 0 Then
                pLevel = pLevel - 1
                i = i + 1
            Else
                Params(UBound(Params)) = Left(sCode, i - 1)
                sCode = mId(sCode, i + 1)
                GoTo done
            End If
        Else
            i = i + 1
        End If
    Wend
done:
    For i = 1 To UBound(Params)
        If i > 1 Then
            sCode = Params(i) & "," & sCode
        Else
            sCode = Params(i) & ")" & sCode
        End If
    Next i
End Sub
