Attribute VB_Name = "modFiles"
Option Explicit

Function GetFullFilename(sFilename As String) As String
    If sFilename = "" Then
        GetFullFilename = ""
        Exit Function
    End If
    sFilename = Replace(sFilename, """", "")
    If Left(sFilename, 1) = "\" Then
        GetFullFilename = CurDir & sFilename
    ElseIf mId(sFilename, 2, 1) <> ":" Then
        GetFullFilename = CurDir & "\" & sFilename
    Else
        GetFullFilename = sFilename
    End If
    GetFullFilename = GetRealFilename(Replace(GetFullFilename, "/", "\"))
End Function

Function GetRealFilename(sFile As String)
    Dim lStart As Long
    GetRealFilename = sFile
    While InStr(GetRealFilename, "\..\") > 0
        lStart = InStr(GetRealFilename, "\..\") - 1
        GetRealFilename = Left(GetRealFilename, InStrRev(Left(GetRealFilename, lStart), "\") - 1) & mId(GetRealFilename, lStart + 4)
    Wend
End Function

Function GetFileTitle(sFilename As String) As String
    sFilename = GetFullFilename(sFilename)
    If InStrRev(sFilename, "\") > 0 Then
        GetFileTitle = mId(sFilename, InStrRev(sFilename, "\") + 1)
    Else
        GetFileTitle = sFilename
    End If
End Function

Function GetFilePath(sFilename As String) As String
    sFilename = GetFullFilename(sFilename)
    GetFilePath = Left(sFilename, InStrRev(sFilename, "\") - 1)
End Function

Function FileExists(sFilename As String) As Boolean
    FileExists = (Dir(GetFullFilename(sFilename)) = GetFileTitle(GetFullFilename(sFilename)))
End Function

Function DirExists(sDir As String) As Boolean
    On Error GoTo err
    Dir sDir, vbDirectory
    DirExists = True
    Exit Function
err:
    DirExists = False
End Function

Sub KillIfExists(sFilename As String)
    If FileExists(sFilename) Then
        Kill GetFullFilename(sFilename)
        DoEvents
    End If
End Sub

Function FileSize(sFilename As String) As Long
    If mId(sFilename, 2, 1) <> ":" And Trim(sCurrentFile) <> "" Then
        sFilename = GetFilePath(GetFullFilename(sCurrentFile)) & "\" & sFilename
    End If
    If Not FileExists(sFilename) Then
        errFileNotFound GetFileTitle(sFilename)
    Else
        FileSize = FileLen(sFilename)
    End If
End Function

Function FileRead(sFilename As String) As String
    Dim FileNum As Long
    If mId(sFilename, 2, 1) <> ":" And Trim(sCurrentFile) <> "" Then
        sFilename = GetFilePath(GetFullFilename(sCurrentFile)) & sFilename
    End If
    If Not FileExists(sFilename) Then
        errFileNotFound GetFileTitle(sFilename)
    Else
        FileNum = FreeFile
        Open GetFullFilename(sFilename) For Input As #FileNum
        FileRead = Input$(LOF(FileNum), #FileNum)
        Close #FileNum
    End If
End Function

Sub FileBinary(sFilename As String)
    Dim FileNum As Long, bTmp As Byte
    If mId(sFilename, 2, 1) <> ":" And Trim(sCurrentFile) <> "" Then
        sFilename = GetFilePath(GetFullFilename(sCurrentFile)) & "\" & sFilename
    End If
    If Not FileExists(sFilename) Then
        errFileNotFound GetFileTitle(sFilename)
    Else
        FileNum = FreeFile
        Open GetFullFilename(sFilename) For Binary As #FileNum
        While Not EOF(FileNum)
            Get #FileNum, , bTmp
            AddCodeByte bTmp
        Wend
        Close #FileNum
    End If
End Sub

Sub FileBin2Res(sFilename As String, lStart As Long, lLen As Long)
    Dim FileNum As Long, i As Long, bTmp As Byte
    If mId(sFilename, 2, 1) <> ":" And Trim(sCurrentFile) <> "" Then
        sFilename = GetFilePath(GetFullFilename(sCurrentFile)) & "\" & sFilename
    End If
    If Not FileExists(sFilename) Then
        errFileNotFound GetFileTitle(sFilename)
    Else
        FileNum = FreeFile
        Open GetFullFilename(sFilename) For Binary As #FileNum
        Seek #FileNum, lStart + 1
        For i = lStart To lStart + lLen - 1
            Get #FileNum, , bTmp
            AddResourceByte bTmp
        Next i
        Close #FileNum
    End If
End Sub

Function DWordFromFile(sFilename As String, lPosition As Long) As Long
    Dim FileNum As Long, i As Long, lTmp As Long: lTmp = 0
    If mId(sFilename, 2, 1) <> ":" And Trim(sCurrentFile) <> "" Then
        sFilename = GetFilePath(GetFullFilename(sCurrentFile)) & "\" & sFilename
    End If
    If Not FileExists(sFilename) Then
        errFileNotFound GetFileTitle(sFilename)
    Else
        FileNum = FreeFile
        Open GetFullFilename(sFilename) For Binary As #FileNum
        Seek #FileNum, lPosition + 1
        Get #FileNum, , lTmp
        Close #FileNum
    End If
    DWordFromFile = lTmp
End Function
