Attribute VB_Name = "modMath"
Option Explicit

Public Const OFFSET_4 = 4294967296#
Public Const MAXINT_4 = 2147483647

Function HiByte(ByVal iWord As Integer) As Byte
    HiByte = (iWord And &HFF00&) \ &H100
End Function

Function LoByte(ByVal iWord As Integer) As Byte
    LoByte = iWord And &HFF
End Function

Function HiWord(lDword As Long) As Integer
    HiWord = (lDword And &HFFFF0000) \ &H10000
End Function

Function LoWord(lDword As Long) As Integer
    If lDword And &H8000& Then
        LoWord = lDword Or &HFFFF0000
    Else
        LoWord = lDword And &HFFFF&
    End If
End Function

Function IsByte(Value As Long) As Boolean
    IsByte = (Value >= -128) And (Value <= 127)
End Function

Function IsWord(Value As Long) As Boolean
    IsWord = (Value >= -32768) And (Value <= 32767)
End Function

Function Multiply(X1 As Long, X2 As Long) As Long
    Dim Y As Double
    Y = LongToUnsigned(X1) * LongToUnsigned(X2)
    If Y > OFFSET_4 Then
        Y = Y - OFFSET_4
    End If
    Multiply = UnsignedToLong(Y)
End Function

Function UnsignedToLong(dValue As Double) As Long
    If dValue < 0 Or dValue >= OFFSET_4 Then Error 6
    If dValue <= MAXINT_4 Then
        UnsignedToLong = dValue
    Else
        UnsignedToLong = dValue - OFFSET_4
    End If
End Function

Function LongToUnsigned(lValue As Long) As Double
    If lValue < 0 Then
        LongToUnsigned = lValue + OFFSET_4
    Else
        LongToUnsigned = lValue
    End If
End Function

Function CharToDigit(sChar As String) As Byte
    If sChar >= "0" And sChar <= "9" Then
        CharToDigit = Asc(sChar) - Asc("0")
    Else
        CharToDigit = Asc(UCase(sChar)) - Asc("A") + 10
    End If
End Function

Function SetDWord(lOffset As Long, lValue As Long)
    CodeSection(lOffset) = LoByte(LoWord(lValue))
    CodeSection(lOffset + 1) = HiByte(LoWord(lValue))
    CodeSection(lOffset + 2) = LoByte(HiWord(lValue))
    CodeSection(lOffset + 3) = HiByte(HiWord(lValue))
End Function
