Attribute VB_Name = "modResources"
Option Explicit

Private Type DirItem
    lType As Long
    sLabel As String
End Type

Private Type ResItem
    lId As Long
    lLang As Long
    sLabel As String
End Type

Private Type IcnItem
    sLabel As String
    sFile As String
End Type

Private Type AccItem
    lFVirt As Integer
    lKey As Integer
    lCmd As Long
End Type

Private Type VerItem
    sName As String
    sValue As String
End Type

Private lLocalCount As Long
Private resource_count As Long, resource_max As Long, resource_min As Long, dialog_count As Long
Private sDirs(24) As String, sRes(24) As String, sSect(24) As String, IDCount As Long

Sub InitResources()
    Dim i As Integer
    lLocalCount = 0
    resource_count = 0
    resource_max = 0
    resource_min = 0
    dialog_count = 0
    IDCount = 1
    For i = 1 To 24
        sDirs(i) = ""
        sRes(i) = ""
        sSect(i) = ""
    Next i
End Sub

Private Function Dir2ID(sDir As String) As Integer
    Select Case sDir
        Case "BITMAP": Dir2ID = 2
        Case "ICON": Dir2ID = 3
        Case "MENU": Dir2ID = 4
        Case "DIALOG": Dir2ID = 5
        Case "ACCELERATOR": Dir2ID = 9
        Case "GROUPICON": Dir2ID = 14
        Case "VERSION": Dir2ID = 16
        Case "MANIFEST": Dir2ID = 24
        Case Else: Dir2ID = 0
    End Select
End Function

Private Function ID2Dir(iID As Integer) As String
    Select Case iID
        Case 2: ID2Dir = "BITMAP"
        Case 3: ID2Dir = "ICON"
        Case 4: ID2Dir = "MENU"
        Case 5: ID2Dir = "DIALOG"
        Case 9: ID2Dir = "ACCELERATOR"
        Case 14: ID2Dir = "GROUPICON"
        Case 16: ID2Dir = "VERSION"
        Case 24: ID2Dir = "MANIFEST"
        Case Else: ID2Dir = ""
    End Select
End Function

Private Sub UseDir(sD As String)
    sDirs(Dir2ID(sD)) = Dir2ID(sD) & "," & LCase(sD) & "s"
End Sub

Private Sub ResAppend(sD As String, sData As String)
    If sRes(Dir2ID(sD)) = "" Then
        sRes(Dir2ID(sD)) = sRes(Dir2ID(sD)) & sData
    Else
        sRes(Dir2ID(sD)) = sRes(Dir2ID(sD)) & "," & sData
    End If
End Sub

Private Sub SectAppend(sD As String, sData As String)
    sSect(Dir2ID(sD)) = sSect(Dir2ID(sD)) & sData & vbCrLf
End Sub

Sub ResAddIcon()
    Dim sTemp As String, sData As String, iGroup As Long, sPre As String, sFile As String
    Blank
    IDCount = IDCount + 1
    iGroup = IDCount
    AddConstant Identifier, iGroup
    sTemp = "": sPre = ""
    sData = "icon group" & iGroup
    While IsSymbol(",")
        Symbol (",")
        IDCount = IDCount + 1
        sTemp = sTemp & sPre & IDCount & ",0," & "icondata" & IDCount
        sPre = ","
        sFile = Text
        If Not FileExists(sFile) Then errFileNotFound sFile
        sData = sData & ",icondata" & IDCount & ",""" & sFile & """"
    Wend
    UseDir "GROUPICON"
    UseDir "ICON"
    ResAppend "GROUPICON", iGroup & ",0,group" & iGroup
    ResAppend "ICON", sTemp
    SectAppend "ICON", sData & ";"
    Terminator
End Sub

Sub ResAddBitmap()
    Dim sFile As String
    Blank
    IDCount = IDCount + 1
    AddConstant Identifier, IDCount
    Symbol (",")
    UseDir "BITMAP"
    ResAppend "BITMAP", IDCount & ",0,bmp" & IDCount
    sFile = Text
    If Not FileExists(sFile) Then errFileNotFound sFile
    SectAppend "BITMAP", "bitmap bmp" & IDCount & ",""" & sFile & """;"
    Terminator
End Sub

Sub ResAddMenu()
    Dim sTemp As String, sCaption As String, bEnd As Boolean, bEnabled As Boolean, bChecked As Boolean
    Blank
    IDCount = IDCount + 1
    AddConstant Identifier, IDCount
    SkipBlank
    Symbol "{"
    SkipBlank
    UseDir "MENU"
    ResAppend "MENU", IDCount & ",0,mnu" & IDCount
    SectAppend "MENU", "menu mnu" & IDCount & ";"
    While Not IsSymbol("}")
        Select Case LCase(Identifier)
        Case "popup"
            Blank
            IDCount = IDCount + 1
            AddConstant Identifier, IDCount
            Symbol (",")
            sCaption = Text
            bEnabled = True: bChecked = False: bEnd = False
            If IsSymbol(",") Then
                Symbol (",")
                bEnabled = Number
                Symbol (",")
                bChecked = Number
            End If
            If IsSymbol(":") Then
                Symbol ":": SkipBlank
                bEnd = False
            Else
                Terminator
                bEnd = True
            End If
            SectAppend "MENU", "menuitem """ & sCaption & """," & IDCount & "," & IIf(bEnd, &H81, 1) & "," & UCase(bEnabled) & "," & UCase(bChecked) & ";"
        Case "item"
            Blank
            IDCount = IDCount + 1
            AddConstant Identifier, IDCount
            Symbol (",")
            sCaption = Text
            bEnabled = True: bChecked = False: bEnd = False
            If IsSymbol(",") Then
                Symbol (",")
                bEnabled = Number
                Symbol (",")
                bChecked = Number
            End If
            If IsSymbol(":") Then
                Symbol ":": SkipBlank
                bEnd = False
            Else
                Terminator
                bEnd = True
            End If
            SectAppend "MENU", "menuitem """ & sCaption & """," & IDCount & "," & IIf(bEnd, &H80, 0) & "," & UCase(bEnabled) & "," & UCase(bChecked) & ";"
        Case "separator"
            Symbol ":": SkipBlank
            SectAppend "MENU", "menuseparator;"
        Case Else
            errUnexpectedEx "'popup', 'item' or 'separator'", "identifier"
        End Select
        If bError Then Exit Sub
    Wend
    SectAppend "MENU", "menuend;"
    SkipBlank
    Symbol "}"
    SkipBlank
End Sub

Sub ResAddDialog()
    Dim sTemp As String
    Blank
    IDCount = IDCount + 1
    AddConstant Identifier, IDCount
    Symbol (",")
    sTemp = "dialog dlg" & IDCount & ",""" & Text & ""","
    Symbol (",")
    sTemp = sTemp & Number & ","
    Symbol (",")
    sTemp = sTemp & Number & ","
    Symbol (",")
    sTemp = sTemp & Number & ","
    Symbol (",")
    sTemp = sTemp & Number & ","
    Symbol (",")
    sTemp = sTemp & Number
    If IsSymbol(",") Then
        Symbol (",")
        sTemp = sTemp & "," & Number & ","
        Symbol (",")
        sTemp = sTemp & Number & ","""
        Symbol (",")
        sTemp = sTemp & Text & ""","
        Symbol (",")
        sTemp = sTemp & Number & ";"
    Else
        sTemp = sTemp & ";"
    End If
    SkipBlank
    Symbol "{"
    SkipBlank
    UseDir "DIALOG"
    ResAppend "DIALOG", IDCount & ",0,dlg" & IDCount
    SectAppend "DIALOG", sTemp
    While Not IsSymbol("}")
        sTemp = "dialogitem """ & UCase(Identifier) & ""","""
        Blank
        IDCount = IDCount + 1
        AddConstant Identifier, IDCount
        Symbol (",")
        sTemp = sTemp & Text & """," & IDCount & ","
        Symbol (",")
        sTemp = sTemp & Number & ","
        Symbol (",")
        sTemp = sTemp & Number & ","
        Symbol (",")
        sTemp = sTemp & Number & ","
        Symbol (",")
        sTemp = sTemp & Number & ","
        Symbol (",")
        sTemp = sTemp & Number
        If IsSymbol(",") Then
            Symbol (",")
            sTemp = sTemp & "," & Number & ";"
        Else
            sTemp = sTemp & ";"
        End If
        Terminator
        If bError Then Exit Sub
        SectAppend "DIALOG", sTemp
    Wend
    SectAppend "DIALOG", "dialogend;"
    SkipBlank
    Symbol "}"
    SkipBlank
End Sub

Sub ResAddAcc()
    Dim sTemp As String, bCtrl As Boolean, bAlt As Boolean, bShift As Boolean, lKey As Long, lCmd As Long
    Blank
    IDCount = IDCount + 1
    AddConstant Identifier, IDCount
    SkipBlank
    Symbol "{"
    SkipBlank
    UseDir "ACCELERATOR"
    ResAppend "ACCELERATOR", IDCount & ",0,acc" & IDCount
    sTemp = "accelerator acc" & IDCount
    While Not IsSymbol("}")
        If Not LCase(Identifier) = "item" Then errUnexpectedEx "'item'", "identifier"
        Blank
        bCtrl = Number
        Symbol (",")
        bAlt = Number
        Symbol (",")
        bShift = Number
        Symbol (",")
        lKey = Number
        Symbol (",")
        lCmd = Number
        Terminator
        If bError Then Exit Sub
        sTemp = sTemp & "," & (1 Or 2 Or IIf(bCtrl, 8, 0) Or IIf(bAlt, 16, 0) Or IIf(bShift, 4, 0)) & "," & lKey & "," & lCmd
    Wend
    SectAppend "ACCELERATOR", sTemp & ";"
    SkipBlank
    Symbol "}"
    SkipBlank
End Sub

Sub ResAddManifest()
    Dim sFile As String, fn As Long
    If sDirs(Dir2ID("MANIFEST")) <> "" Then Exit Sub
    UseDir "MANIFEST"
    ResAppend "MANIFEST", 1 & ",0,mf"
    sFile = App.Path & "\manifest.tmp"
    fn = FreeFile
    Open sFile For Binary As #fn
    Put #fn, , "<?xml version=""1.0"" encoding=""UTF-8"" standalone=""yes""?>" & vbCrLf
    Put #fn, , "<assembly" & vbCrLf
    Put #fn, , "  xmlns=""urn:schemas-microsoft-com:asm.v1""" & vbCrLf
    Put #fn, , "  manifestVersion=""1.0"">" & vbCrLf
    Put #fn, , "<assemblyIdentity" & vbCrLf
    Put #fn, , "    name=""" & sTitle & """" & vbCrLf
    Put #fn, , "    processorArchitecture=""x86""" & vbCrLf
    Put #fn, , "    version=""" & sVersion & """" & vbCrLf
    Put #fn, , "    type=""win32""/>" & vbCrLf
    Put #fn, , "<description>" & sDescription & "</description>" & vbCrLf
    Put #fn, , "<dependency>" & vbCrLf
    Put #fn, , "    <dependentAssembly>" & vbCrLf
    Put #fn, , "        <assemblyIdentity" & vbCrLf
    Put #fn, , "            type=""win32""" & vbCrLf
    Put #fn, , "            name=""Microsoft.Windows.Common-Controls""" & vbCrLf
    Put #fn, , "            version=""6.0.0.0""" & vbCrLf
    Put #fn, , "            processorArchitecture=""x86""" & vbCrLf
    Put #fn, , "            publicKeyToken=""6595b64144ccf1df""" & vbCrLf
    Put #fn, , "            language=""*""" & vbCrLf
    Put #fn, , "        />" & vbCrLf
    Put #fn, , "    </dependentAssembly>" & vbCrLf
    Put #fn, , "</dependency>" & vbCrLf
    Put #fn, , "</assembly>" & vbCrLf
    Close #fn
    SectAppend "MANIFEST", "fileres mf,""" & sFile & """;"
End Sub

Sub ResAddVersion()
    IDCount = IDCount + 1
    UseDir "VERSION"
    ResAppend "VERSION", "1,0,vers" & IDCount
    SectAppend "VERSION", "version vers" & IDCount & ",4,1,0,0,0,""FileDescription"",""" & sDescription & """,""LegalCopyright"",""" & _
        sCopyright & """,""FileVersion"",""" & sVersion & """,""ProductVersion"",""" & sVersion & """,""OriginalFilename"",""" & GetFileTitle(Left(frmMain.ActiveForm.Filename, InStrRev(frmMain.ActiveForm.Filename, ".")) & "exe") & """;"
End Sub

Private Sub GenerateResources()
    Dim i As Integer, sPre As String
    sCode = "{" & vbCrLf & "directory "
    sPre = ""
    For i = 1 To 24
        If sDirs(i) <> "" Then
            sCode = sCode & sPre & sDirs(i)
            sPre = ","
        End If
    Next i
    sCode = sCode & ";" & vbCrLf
    For i = 1 To 24
        If sRes(i) <> "" Then
            sCode = sCode & "resource " & LCase(ID2Dir(i)) & "s," & sRes(i) & ";" & vbCrLf
        End If
    Next i
    For i = 1 To 24
        If sSect(i) <> "" Then sCode = sCode & sSect(i)
    Next i
    sCode = sCode & "}"
    If sCode = "{" & vbCrLf & "directory ;" & vbCrLf & "}" Then sCode = "{}"
End Sub

Private Sub ResDirectory()
    Dim Param() As DirItem
    Dim lNum As Long, i As Long, ii As Long, iT As Long
    ReDim Preserve Param(0) As DirItem
    Blank
    resource_count = 0
    resource_max = 0
loopx:
    resource_count = resource_count + 1
    lNum = Number
    If lNum > resource_max Then
        resource_max = lNum
    End If
    Symbol (",")
    ReDim Preserve Param(UBound(Param) + 1) As DirItem
    Param(UBound(Param)).lType = lNum
    Param(UBound(Param)).sLabel = Identifier
    If IsSymbol(",") Then
        Symbol (",")
        GoTo loopx
    End If
    AddSymbol "resource_root", 0, stResource, stFunction, ""
    AddResourceDWord 0
    AddResourceDWord 0
    AddResourceDWord 0
    AddResourceWord 0
    AddResourceWord LoWord(resource_count)
    For i = 1 To resource_max
        iT = -1
        For ii = 1 To UBound(Param)
            If Param(ii).lType = i Then
                iT = ii
                Exit For
            End If
        Next ii
        If iT > -1 Then
            AddResourceDWord i
            ResourceFixup Param(iT).sLabel, &H80000000, "resource_root"
        End If
    Next i
    Terminator
End Sub

Private Sub ResResource()
    Dim Param() As ResItem, i As Long, ii As Long
    ReDim Preserve Param(0) As ResItem
    Blank
    AddSymbol Identifier, 0, stResource, stFunction, ""
loopx:
    Symbol (",")
    ReDim Preserve Param(UBound(Param) + 1) As ResItem
    Param(UBound(Param)).lId = Number
    Symbol (",")
    Param(UBound(Param)).lLang = Number
    Symbol (",")
    Param(UBound(Param)).sLabel = Identifier
    resource_min = Param(UBound(Param)).lId
    resource_max = Param(UBound(Param)).lId
    If IsSymbol(",") Then GoTo loopx
    resource_count = 0
    For i = 1 To UBound(Param)
        resource_count = resource_count + 1
        If Param(i).lId < resource_min Then
            resource_min = Param(i).lId
        ElseIf Param(i).lId > resource_max Then
            resource_max = Param(i).lId
        End If
    Next i
    AddResourceDWord 0
    AddResourceDWord 0
    AddResourceDWord 0
    AddResourceWord 0
    AddResourceWord LoWord(resource_count)
    For ii = 1 To resource_max - resource_min + 1
        For i = 1 To UBound(Param)
            If resource_min + ii - 1 = Param(i).lId Then
                AddResourceDWord Param(i).lId
                ResourceFixup "$" & Param(i).sLabel, &H80000000, "resource_root"
            End If
        Next i
    Next ii
    For i = 1 To UBound(Param)
        AddConstant Param(i).sLabel & ".resid", Param(i).lId
        AddSymbol "$" & Param(i).sLabel, 0, stResource, stFunction, ""
        AddResourceDWord 0
        AddResourceDWord 0
        AddResourceDWord 0
        AddResourceDWord &H10000
        AddResourceDWord Param(i).lLang
        ResourceFixup Param(i).sLabel, 0, "resource_root"
    Next i
    Terminator
End Sub

Private Sub ResIcon()
    Dim Param() As IcnItem, i As Long
    Dim count As Long, sGroup As String, lPos As Long, lSize As Long
    ReDim Preserve Param(0) As IcnItem
    Blank
    count = 0
    sGroup = Identifier
loopx:
    Symbol (",")
    ReDim Preserve Param(UBound(Param) + 1) As IcnItem
    Param(UBound(Param)).sLabel = Identifier
    Symbol (",")
    Param(UBound(Param)).sFile = Text
    If IsSymbol(",") Then GoTo loopx
    For i = 1 To UBound(Param)
        lPos = DWordFromFile(Param(i).sFile, 18)
        lSize = DWordFromFile(Param(i).sFile, 14)
        AddSymbol Param(i).sLabel, 0, stResource, stFunction, ""
        ResourceFixup "$$" & Param(i).sLabel, 0, "RVA"
        AddResourceDWord lSize
        AddResourceDWord 0
        AddResourceDWord 0
        AddSymbol "$$" & Param(i).sLabel, 0, stResource, stFunction, ""
        FileBin2Res Param(i).sFile, lPos, lSize
        count = count + 1
    Next i
    ResourceAlign
    AddSymbol sGroup, 0, stResource, stFunction, ""
    lLocalCount = lLocalCount + 1
    ResourceFixup "$header" & lLocalCount, 0, "RVA"
    AddResourceDWord 6 + (count * 14)
    AddResourceDWord 0
    AddResourceDWord 0
    AddSymbol "$header" & lLocalCount, 0, stResource, stFunction, ""
    AddResourceWord 0
    AddResourceWord 1
    AddResourceWord LoWord(count)
    For i = 1 To UBound(Param)
        FileBin2Res Param(i).sFile, 6, 12
        AddResourceWord LoWord(GetConstant(Param(i).sLabel & ".resid"))
    Next i
    ResourceAlign
    Terminator
End Sub

Private Sub ResBitmap()
    Dim sFile As String
    Blank
    AddSymbol Identifier, 0, stResource, stFunction, ""
    Symbol (",")
    sFile = Text
    lLocalCount = lLocalCount + 1
    ResourceFixup "$bitmapdata" & lLocalCount, 0, "RVA"
    AddResourceDWord FileSize(sFile) - &HE
    AddResourceDWord 0
    AddResourceDWord 0
    AddSymbol "$bitmapdata" & lLocalCount, 0, stResource, stFunction, ""
    FileBin2Res sFile, &HE, FileSize(sFile) - &HE
    ResourceAlign
    Terminator
End Sub

Private Sub ResFileRes()
    Dim sFile As String
    Blank
    AddSymbol Identifier, 0, stResource, stFunction, ""
    Symbol (",")
    sFile = Text
    lLocalCount = lLocalCount + 1
    ResourceFixup "$filedata" & lLocalCount, 0, "RVA"
    AddResourceDWord FileSize(sFile)
    AddResourceDWord 0
    AddResourceDWord 0
    AddSymbol "$filedata" & lLocalCount, 0, stResource, stFunction, ""
    FileBin2Res sFile, 0, FileSize(sFile)
    ResourceAlign
    Terminator
End Sub

Private Sub ResMenu()
    Dim sFile As String
    Blank
    AddSymbol Identifier, 0, stResource, stFunction, ""
    lLocalCount = lLocalCount + 1
    ResourceFixup "$menudata" & lLocalCount, 0, "RVA"
    ResourceFixup "$menusize" & lLocalCount, 0, "$menudata" & lLocalCount
    AddResourceDWord 0
    AddResourceDWord 0
    AddSymbol "$menudata" & lLocalCount, 0, stResource, stFunction, ""
    AddResourceWord 1
    AddResourceWord 4
    AddResourceWord 0
    AddResourceWord 0
    Terminator
End Sub

Private Sub ResMenuItem()
    Dim mId As Long, mInfo As Long, mText As String, bEnabled As Boolean, bChecked As Boolean
    Blank
    mText = Text
    Symbol (",")
    mId = Number
    Symbol (",")
    mInfo = Number
    bEnabled = True
    bChecked = False
    If IsSymbol(",") Then
        Symbol (",")
        bEnabled = Number
        Symbol (",")
        bChecked = Number
    End If
    AddResourceDWord 0
    AddResourceDWord IIf(bEnabled, 0, 3) Or IIf(bChecked, 8, 0)
    AddResourceDWord mId
    AddResourceWord LoWord(mInfo)
    AddResourceString mText
    ResourceAlign
    If mInfo And 1 Then AddResourceDWord 0
    Terminator
End Sub

Private Sub ResMenuSeparator()
    AddResourceDWord &H800
    AddResourceDWord 0
    AddResourceDWord 0
    AddResourceWord 0
    AddResourceWord 0
    Terminator
End Sub

Private Sub ResMenuEnd()
    AddSymbol "$menusize" & lLocalCount, 0, stResource, stFunction, ""
    Terminator
End Sub

Private Sub ResDialog()
    Dim label As String, title As String, X As Integer, Y As Integer, cx As Integer, cy As Integer
    Dim style As Long, menu As Integer, exstyle As Long, fontname As String, fontsize As Integer
    Blank
    label = Identifier
    Symbol (",")
    title = Text
    Symbol (",")
    X = Number
    Symbol (",")
    Y = Number
    Symbol (",")
    cx = Number
    Symbol (",")
    cy = Number
    Symbol (",")
    style = Number
    menu = 0
    If IsSymbol(",") Then
        Symbol (",")
        menu = Number
    End If
    exstyle = 0
    If IsSymbol(",") Then
        Symbol (",")
        exstyle = Number
    End If
    fontname = "MS Sans Serif"
    If IsSymbol(",") Then
        Symbol (",")
        fontname = Text
    End If
    fontsize = 8
    If IsSymbol(",") Then
        Symbol (",")
        fontsize = Number
    End If
    dialog_count = 0
    AddSymbol label, 0, stResource, stFunction, ""
    lLocalCount = lLocalCount + 1
    ResourceFixup "$dialogdata" & lLocalCount, 0, "RVA"
    ResourceFixup "$dialogsize" & lLocalCount, 0, "$dialogdata" & lLocalCount
    AddResourceDWord 0
    AddResourceDWord 0
    AddSymbol "$dialogdata" & lLocalCount, 0, stResource, stFunction, ""
    AddResourceDWord style Or &H40
    AddResourceDWord exstyle
    ResourceFixupWord "$dialogitems" & lLocalCount
    AddResourceWord X
    AddResourceWord Y
    AddResourceWord cx
    AddResourceWord cy
    If menu <> 0 Then
        AddResourceWord &HFFFF
    End If
    AddResourceWord menu
    AddResourceWord 0
    AddResourceString title
    AddResourceWord fontsize
    AddResourceString fontname
    ResourceAlign
    Terminator
End Sub

Private Sub ResDialogItem()
    Dim Class As String, sTitle As String, ltitle As Integer, id As Integer, bIsText As Boolean
    Dim X As Integer, Y As Integer, cx As Integer, cy As Integer, style As Long, exstyle As Long
    Blank
    Class = Text
    Symbol (",")
    If IsText Then
        sTitle = Text
        bIsText = True
    Else
        ltitle = Number
        bIsText = False
    End If
    Symbol (",")
    id = Number
    Symbol (",")
    X = Number
    Symbol (",")
    Y = Number
    Symbol (",")
    cx = Number
    Symbol (",")
    cy = Number
    Symbol (",")
    style = Number
    exstyle = 0
    If IsSymbol(",") Then
        Symbol (",")
        exstyle = Number
    End If
    dialog_count = dialog_count + 1
    AddResourceDWord style Or &H40000000
    AddResourceDWord exstyle
    AddResourceWord X
    AddResourceWord Y
    AddResourceWord cx
    AddResourceWord cy
    AddResourceWord id
    Select Case Class
    Case "BUTTON"
        AddResourceWord &HFFFF
        AddResourceWord &H80
    Case "EDIT"
        AddResourceWord &HFFFF
        AddResourceWord &H81
    Case "STATIC"
        AddResourceWord &HFFFF
        AddResourceWord &H82
    Case "LISTBOX"
        AddResourceWord &HFFFF
        AddResourceWord &H83
    Case "SCROLLBAR"
        AddResourceWord &HFFFF
        AddResourceWord &H84
    Case "COMBOBOX"
        AddResourceWord &HFFFF
        AddResourceWord &H85
    Case Else
        AddResourceString Class
    End Select
    If bIsText Then
        AddResourceString sTitle
    Else
        AddResourceWord &HFFFF
        AddResourceWord ltitle
    End If
    AddResourceWord 0
    ResourceAlign
    Terminator
End Sub

Private Sub ResDialogEnd()
    AddSymbol "$dialogitems" & lLocalCount, 0, stResource, stFunction, "", dialog_count
    AddSymbol "$dialogsize" & lLocalCount, 0, stResource, stFunction, ""
    Terminator
End Sub

Private Sub ResAccelerator()
    Dim label As String, Param() As AccItem, i As Long, lCount As Long
    ReDim Preserve Param(0) As AccItem
    Blank
    label = Identifier: lCount = 0
    If Not IsSymbol(",") Then errUnexpected "','"
    While IsSymbol(",")
        Symbol (",")
        ReDim Preserve Param(UBound(Param) + 1) As AccItem
        Param(UBound(Param)).lFVirt = Number
        Symbol (",")
        Param(UBound(Param)).lKey = Number
        Symbol (",")
        Param(UBound(Param)).lCmd = Number
        lCount = lCount + 1
    Wend
    AddSymbol label, 0, stResource, stFunction, ""
    lLocalCount = lLocalCount + 1
    ResourceFixup "$accdata" & lLocalCount, 0, "RVA"
    AddResourceDWord lCount * 8
    AddResourceDWord 0
    AddResourceDWord 0
    AddSymbol "$accdata" & lLocalCount, 0, stResource, stFunction, ""
    i = 1
    While lCount > 0
        lCount = lCount - 1
        If lCount = 0 Then
            AddResourceWord Param(i).lFVirt Or &H80
        Else
            AddResourceWord Param(i).lFVirt
        End If
        AddResourceWord Param(i).lKey
        AddResourceDWord Param(i).lCmd
        i = i + 1
    Wend
    Terminator
End Sub

Sub ResVersion()
    Dim Param() As VerItem, i As Long
    Dim lOffSize As Long, lOffViSize As Long, lViValue As Long, iLang As Integer, iCP As Integer
    Dim FV1 As Integer, FV2 As Integer, FV3 As Integer, FV4 As Integer
    Dim PV1 As Integer, PV2 As Integer, PV3 As Integer, PV4 As Integer
    Dim lParam1 As Long, lParam2 As Long, lParam3 As Long
    Dim vs_size As Integer, value_size As Integer, tmp() As String
    ReDim Preserve Param(0) As VerItem
    
    Blank
    AddSymbol Identifier, 0, stResource, stFunction, ""
    lLocalCount = lLocalCount + 1
    ResourceFixup "$versiondata" & lLocalCount, 0, "RVA"
    ResourceFixup "$versionsize" & lLocalCount, 0, "$versiondata" & lLocalCount
    AddResourceDWord 0
    AddResourceDWord 0
    AddSymbol "$versiondata" & lLocalCount, 0, stResource, stFunction, ""
    lOffSize = UBound(ResourceSection) + 1
    AddResourceWord 0
    lOffViSize = UBound(ResourceSection) + 1
    AddResourceWord 0
    AddResourceWord 0
    AddResourceString "VS_VERSION_INFO"
    AddResourceWord 0
    lViValue = UBound(ResourceSection) + 1
    AddResourceDWord &HFEEF04BD
    AddResourceDWord &H10000
    
    Symbol (",")
    lParam1 = Number
    Symbol (",")
    lParam2 = Number
    Symbol (",")
    lParam3 = Number
    Symbol (",")
    iLang = Number
    Symbol (",")
    iCP = Number
    
    FV1 = 1: FV2 = 0: FV3 = 0: FV4 = 0
    PV1 = 1: PV2 = 0: PV3 = 0: PV4 = 0
    
    While IsSymbol(",")
        Symbol (",")
        ReDim Preserve Param(UBound(Param) + 1) As VerItem
        Param(UBound(Param)).sName = Text
        Symbol (",")
        Param(UBound(Param)).sValue = Text
        If Param(UBound(Param)).sName = "FileVersion" Then
            tmp = Split(Param(UBound(Param)).sValue, ".")
            FV1 = CInt(tmp(0))
            If UBound(tmp) > 0 Then FV2 = CInt(tmp(1))
            If UBound(tmp) > 1 Then FV3 = CInt(tmp(2))
            If UBound(tmp) > 2 Then FV4 = CInt(tmp(3))
        ElseIf Param(UBound(Param)).sName = "ProductVersion" Then
            tmp = Split(Param(UBound(Param)).sValue, ".")
            PV1 = CInt(tmp(0))
            If UBound(tmp) > 0 Then PV2 = CInt(tmp(1))
            If UBound(tmp) > 1 Then PV3 = CInt(tmp(2))
            If UBound(tmp) > 2 Then PV4 = CInt(tmp(3))
        End If
    Wend

    AddResourceWord FV2
    AddResourceWord FV1
    AddResourceWord FV4
    AddResourceWord FV3
    AddResourceWord PV2
    AddResourceWord PV1
    AddResourceWord PV4
    AddResourceWord PV3
    
    AddResourceDWord 0
    AddResourceDWord 0
    AddResourceDWord lParam1
    AddResourceDWord lParam2
    AddResourceDWord lParam3
    AddResourceDWord 0
    AddResourceDWord 0

    ResourceSection(lOffViSize) = LoByte(LoWord(UBound(ResourceSection) - lViValue + 1))
    ResourceSection(lOffViSize + 1) = HiByte(LoWord(UBound(ResourceSection) - lViValue + 1))

    AddSymbol "$sfidata" & lLocalCount, 0, stResource, stFunction, ""
    ResourceFixup "$sssize" & lLocalCount, 0, "$sfidata" & lLocalCount
    AddResourceWord 1
    AddResourceString "StringFileInfo"
    AddSymbol "$strdata" & lLocalCount, 0, stResource, stFunction, ""
    ResourceFixup "$sssize" & lLocalCount, 0, "$strdata" & lLocalCount
    AddResourceWord 1
    AddResourceString "040904E4"
    
    For i = 1 To UBound(Param)
        ResourceAlign
        value_size = (Len(Param(i).sValue) + 1) * 2
        vs_size = Align4(8 + (Len(Param(i).sName) * 2)) + value_size
        AddResourceWord vs_size
        AddResourceWord value_size / 2
        AddResourceWord 1
        AddResourceString Param(i).sName
        ResourceAlign
        AddResourceString Param(i).sValue
    Next i
    
    ResourceAlign
    AddSymbol "$sssize" & lLocalCount, 0, stResource, stFunction, ""
    
    AddResourceDWord 68
    AddResourceWord 1
    AddResourceString "VarFileInfo"
    AddResourceWord 0
    AddResourceWord 36
    AddResourceWord 4
    AddResourceWord 0
    AddResourceString "Translation"
    AddResourceWord 0
    AddResourceWord iLang
    AddResourceWord iCP
    
    ResourceSection(lOffSize) = LoByte(LoWord(UBound(ResourceSection) - lOffSize + 1))
    ResourceSection(lOffSize + 1) = HiByte(LoWord(UBound(ResourceSection) - lOffSize + 1))
    AddSymbol "$versionsize" & lLocalCount, 0, stResource, stFunction, ""
    Terminator
End Sub

Sub Resources()
    Dim sIdent As String
    lLocalCount = 0
    GenerateResources
    Symbol "{": SkipBlank
    While Not IsSymbol("}")
        If IsIdentifier Then
            sIdent = Identifier
            Select Case LCase(sIdent)
            Case "directory"
                ResDirectory
            Case "resource"
                ResResource
            Case "icon"
                ResIcon
            Case "bitmap"
                ResBitmap
            Case "fileres"
                ResFileRes
            Case "menu"
                ResMenu
            Case "menuitem"
                ResMenuItem
            Case "menuseparator"
                ResMenuSeparator
            Case "menuend"
                ResMenuEnd
            Case "dialog"
                ResDialog
            Case "dialogitem"
                ResDialogItem
            Case "dialogend"
                ResDialogEnd
            Case "accelerator"
                ResAccelerator
            Case "version"
                ResVersion
            Case Else
                If IsSymbol("=") Then
                    Symbol "="
                    AddConstant sIdent, Number
                    Terminator
                Else
                    errInvalidDirective sIdent
                End If
            End Select
        End If
        If Len(sCode) = 0 Then Exit Sub
    Wend
    Symbol "}"
    KillIfExists App.Path & "\manifest.tmp"
End Sub
